import Fastify from "fastify";
import FastifyStatic from "@fastify/static";
import path from "path";
import { ToDo } from "../lib/models.js";
import fs from "fs";
import nunjucks from "nunjucks";

export const description = "Runs your app.";

export const options = [];

export const required = [];

const fastify = Fastify({
  logger: true
});


fastify.get("/todo", async (req, rep) => {
  try {
    const todo_list = await ToDo.all({});

    // this is for exporing the problem of getting good error messages from templates
    const result = nunjucks.render("templates/todo.html",
      {todo_list, your_todos: "Your Todos"});

    rep.code(200)
      .type("text/html")
      .send(result);
  } catch(error) {
    console.error(error);
    console.error(error.stack);
    console.error(error.source);
  }
});

fastify.register(FastifyStatic, {
  root: path.join(path.resolve("."), 'static'),
  prefix: '/', // optional: default '/'
  constraints: {}, // optional: default {}
  index: "index.html"
})

export const main = async (arg, opts) => {
  try {
    await fastify.listen({port: 3000});
  } catch(err) {
    fastify.log.error(err);
    process.exit(1);
  }
}
